/*  Generated Thu Nov 25 09:58:06 EST 2010 by JBurg version 1.6.3 */

#include <iostream>
#include <string>
#include <stack>
#include <exception>
#include <memory>
#include <sstream>
#include "jburgsupp.h"

    #include <iostream>

class JBurgCppTestEmitter: public ArithmeticTokenHolder
{
private:

	std::stack<void*> __reducedValues;

	int	*antecedentRules;

public:

	JBurgCppTestEmitter() {
		antecedentRules = new int[nStates];
	}

	~JBurgCppTestEmitter() {
		if( antecedentRules ) delete[] antecedentRules;
	}


public:
static const int __expression_NT = 1;
public:
static const int nStates = 1;
public:
JBurgAnnotation<TestINode>* label( TestINode* to_be_labelled )
{
	JBurgAnnotation<TestINode>* result = NULL;
	int i;
	int arity;
	if ( to_be_labelled )
	{
		result = new JBurgAnnotation<TestINode>(to_be_labelled,nStates + 1);
		arity = to_be_labelled->getArity();
		i = 0;
		while ( ( arity > i ) )
		{
			
			result->addChild(this->label(((TestINode*)to_be_labelled->getNthChild(i))));
			i =  (i + 1) ;
			
		}
		this->computeCostMatrix(result);
		
	}
	return (result);
	
}
private:
void computeCostMatrix( JBurgAnnotation<TestINode>* node )
{
	int iCost;
	switch( node->getOperator() )
	{
		case INT:
		{
			
			if ( node->getArity()==0 )
			{
				
				iCost = 1;
				if ( ( node->getCost(__expression_NT) > iCost )  )
				{
					
					/* Matched INT ==> expression */

					node->reset(__expression_NT, iCost, 3);
					
				}
				
			}
			break;
		}
		case ADD:
		{
			
			if ( node->getArity()==2 && ( MAX_INT_VALUE > node->getNthChild(0)->getCost(__expression_NT) )  && ( MAX_INT_VALUE > node->getNthChild(1)->getCost(__expression_NT) )  )
			{
				
				iCost =  (1 +  (node->getNthChild(1)->getCost(__expression_NT) + node->getNthChild(0)->getCost(__expression_NT)) ) ;
				if ( ( node->getCost(__expression_NT) > iCost )  )
				{
					
					/* Matched ADD ==> expression */

					node->reset(__expression_NT, iCost, 2);
					node->addSubgoal(__expression_NT, node->getNthChild(1), __expression_NT);
					node->addSubgoal(__expression_NT, node->getNthChild(0), __expression_NT);
					
				}
				
			}
			break;
		}
		
	}
	
}

/* expression */
private:
int action_2( TestINode* __p )
{
	

	int r((int)__reducedValues.top());
	__reducedValues.pop();
	

	int l((int)__reducedValues.top());
	__reducedValues.pop();
	
		{
		    return l + r;
		}
}

/* expression */
private:
int action_3( TestINode* __p )
{
	
		{
		    return atoi(__p->getText().c_str());
		}
}
private:
void dispatchAction( TestINode* __p, int iRule )
{
	switch( iRule )
	{
		case 1:
		{
			/* Don't reduce or touch the stack. */

			break;
		}
		case 2:
		{
			__reducedValues.push( (void*)(this->action_2(__p)));
			break;
		}
		case 3:
		{
			__reducedValues.push( (void*)(this->action_3(__p)));
			break;
		}
		default:throw std::string("Unmatched reduce action " + iRule);
		
	}
	
}


	void reduce ( JBurgAnnotation<TestINode >* p, int goalState )
	{
		int iRule = -1;

		if ( goalState > 0 ) {
			iRule = p->getRule(goalState);
		} else {
			//  Find the minimum-cost path.
			int minCost = MAX_INT_VALUE;
			for (int i = 0; i <= nStates ; ++i ) {
				if ( p->getCost(i) < minCost ) {
					iRule = p->getRule(i);
					minCost = p->getCost(i);
					goalState = i;
				}
			}
		}

		if ( iRule > 0 )
		{
			
			reduceAntecedentStates(p, goalState);
			if ( p->isNary(goalState) )
			{
			/* Aggregate the operands of an n-ary operator into a single container. */std::vector<void*>* variadic_result = new std::vector<void*>;
			for ( int i = 0; i < p->getArity(); i++ )
			{
				reduce(p->getNthChild(i), p->getNarySubgoal(goalState));
				variadic_result->push_back(__reducedValues.top());
				__reducedValues.pop();
			}
			__reducedValues.push(variadic_result);
			}
			reduceSubgoals(p, goalState);

			dispatchAction ( p->getNode(), iRule );
		}
		else
		{
			std::stringstream s;
			s << "Unable to find a rule to process ";
			s << p->getNode()->toString();
			s << " (" << p->getOperator() << ") {" << goalState << "}";
			throw new std::runtime_error ( s.str() );
		}
	}

	void reduceAntecedentStates( JBurgAnnotation<TestINode >* p, int goalState)
	{
		int   currentState = goalState;
		std::vector<int> antecedent_states;
		std::vector<int> antecedent_rules;

		//  If X is antecedent of Y, then the reduce action
		//  for X must occur before the reduce action of Y.
		//  The antecdents must therefore be processed 
		//  from "back" to "front."
		while ( p->hasAntecedent(currentState)  )
		{
			currentState = p->getAntecedent(currentState);
			antecedent_states.push_back(currentState);
			antecedent_rules.push_back(p->getRule(currentState));
		}
		while ( ! antecedent_states.empty() )
		{
			reduceSubgoals(p, antecedent_states.back());
			dispatchAction( p->getNode(), antecedent_rules.back());
			antecedent_states.pop_back();
			antecedent_rules.pop_back();
		}
	}
	void reduceSubgoals( JBurgAnnotation<TestINode >* p, int goalState)
	{
	/* Reduce subgoals in reverse order so they get pushed onto the stack */
	/* in the order expected by the action routines. */
		for ( int i = p->getSubgoalsSize(goalState) - 1; i >= 0; i-- )
		{
			JBurgAnnotation<TestINode>::JBurgSubgoal sg = p->getSubgoals(goalState)[i];
			reduce ( sg.getNode(), sg.getGoalState());
		}
	}

public:

	void burm ( TestINode* root )
	{		burm(root,0);	}	void burm ( TestINode* root, int goal_state )
	{
		JBurgAnnotation<TestINode >* annotatedTree = label(root);
		reduce ( annotatedTree, goal_state);
		delete annotatedTree;
	}

void* getResult() {
    return __reducedValues.top();
}
private:
int getArityOf( TestINode* node )
{
		return node->getArity();
}
private:
TestINode* getNthChild( TestINode* node, int idx )
{
		return node->getNthChild(idx);
}

int getNaryCost( JBurgAnnotation<TestINode>* node, int goalState)
{
	int i = 0;
	int accum = 0;
	
	for ( i = 0; i < node->getArity(); i++ )
	{
		
		accum += node->getCost(goalState);
		
	}
	
	return (accum);
	
}


};
